;eax -> irow
;ecx -> cuento columnas
;esi -> p_inrow
;edi -> p_outrow

section .text

%include "macros.mac"

%define inn [ebp+8]
%define outt [ebp+12]
%define dataOut [ebp-4]
%define dataIn [ebp-8]
%define widthstep [ebp-12]
%define filas [ebp-16]
%define cols [ebp-20]
%define total [ebp-24]
%define pHistograma [ebp-28]
%define mascara [ebp-44]
%define HistoXmm [ebp-60]
%define lineade4 [ebp-76]

global brillohistoAsm
extern printf
extern calloc

brillohistoAsm:
	convencionC 76

	mov esi, inn
	mov eax, [esi + 8]
	mov eax, [esi + 68]
	mov dataIn, eax
	mov eax, [esi + 72]
	mov widthstep, eax
	mov eax, [esi +  44]
	mov filas, eax
	mov eax, [esi + 40]
	mov cols, eax

	pedirMemoriaVacia 4, 256
	mov pHistograma, eax

	mov eax, filas
	mov ebx, cols
	mul ebx
	mov total, eax

	pxor xmm4, xmm4
	mov eax, 4
	pinsrd xmm4, eax, 0
	pshufd xmm4, xmm4, 00000000b
	movdqu lineade4, xmm4

	pxor xmm5, xmm5
	pinsrd xmm5, pHistograma, 0
	pshufd xmm5, xmm5, 00000000b
	movdqu HistoXmm, xmm5

	pxor xmm6, xmm6
	mov eax, 3
	pinsrd xmm6, eax, 0
	pshufd xmm6, xmm6, 00000000b
	cvtdq2ps xmm6, xmm6

	xor eax, eax
	
.filasContarHisto:
	push eax
	mul DWORD widthstep
	add eax, dataIn
	mov esi, eax; p_inrow
	xor ecx, ecx	

.colsContarHisto:
	movdqu xmm0, [esi]
	movdqu xmm1, xmm0
	
	pxor xmm7, xmm7
	punpcklbw xmm0, xmm7
	punpckhbw xmm1, xmm7; tengo 2 pixeles en cada xmm

	phaddw xmm0, xmm7
	phaddw xmm0, xmm7; en las dos primeras words tengo las sumatorias de cada pixel

	phaddw xmm1, xmm7
	phaddw xmm1, xmm7; en las dos primeras words tengo las sumatorias de cada pixel

	punpcklwd xmm0, xmm7;
	punpcklwd xmm1, xmm7;las paso a doubleword

	cvtdq2ps xmm0, xmm0
	cvtdq2ps xmm1, xmm1;los paso a flotante

	divps xmm0, xmm6;divido por tres
	divps xmm1, xmm6
	
	cvtps2dq xmm0, xmm0
	cvtps2dq xmm1, xmm1

	packusdw xmm0, xmm1; ahora estan los 4 promedios juntos, en forma de words
	pshufd xmm0, xmm0, 11011000b ; las pongo juntas, para pasarlas a doubleword
	punpcklwd xmm0, xmm7; las paso a doublewords
	pmulld xmm0, xmm4; multiplico los valores por cuatro
	paddd xmm0, xmm5; les sumo el valor inicial del arreglo histograma, y así obtengo los índices
	
;ahora tomo cada uno de los indices y hago histograma[indice]++
	pextrd eax, xmm0, 0
	inc dword [eax]
	pextrd eax, xmm0, 1
	inc dword [eax]
	pextrd eax, xmm0, 2
	inc dword [eax]
	pextrd eax, xmm0, 3
	inc dword [eax]
	
	add esi, 16
	add ecx, 4
	mov ebx, cols
	sub ebx, ecx
	cmp ebx, 0
	jg .colsContarHisto
	pop eax
	inc eax
	cmp eax, filas
	jl .filasContarHisto
	
	xor ecx, ecx
	xor edi, edi; edi va a tener el totalParcial
	mov ebx, pHistograma
	mov edx, total
	finit
.calcularHisto:
	mov eax, ecx
	mov esi, 4
	mul esi
	add eax, ebx; tengo el puntero al indice
	push eax; guardo el puntero en la cola
	mov eax, [eax]; traigo el valor
	mov esi, 255
	mul esi; histograma[i] * 255
	add edi, eax; totalParcial += histograma[i] * 255
	push edi
	fild dword [esp]; [totalParcial]
	pop edi
	fild dword total; [total, totalParcial]
	fdivp ;[totalparcial/total]
	pop eax; traigo el puntero al indice
	fistp dword [eax]; histograma[i] = totalParcial/total
	inc ecx
	cmp ecx, 256
	jl .calcularHisto
	
	mov esi, inn
	mov edi, outt
	mov eax, [edi + 68]
	mov dataOut, eax
	xor eax, eax

.filasCalcular:
	push eax
	mul DWORD widthstep
	add eax, dataIn
	mov esi, eax; p_inrow
	mov eax, [esp]
	mul DWORD widthstep
	add eax, dataOut
	mov edi, eax; p_outrow
	xor ecx, ecx	
.colsCalcular:
	movdqu xmm2, [esi]
	movdqu xmm3, xmm2
	movdqu xmm4, xmm2
	movdqu xmm5, xmm4
	
	pxor xmm7, xmm7
	punpcklbw xmm2, xmm7
	punpckhbw xmm3, xmm7; tengo 2 pixeles en cada xmm

	phaddw xmm2, xmm7
	phaddw xmm2, xmm7; en las dos primeras words tengo las sumatorias de cada pixel

	phaddw xmm3, xmm7
	phaddw xmm3, xmm7; en las dos primeras words tengo las sumatorias de cada pixel

	punpcklwd xmm2, xmm7;
	punpcklwd xmm3, xmm7;las paso a doubleword

	cvtdq2ps xmm2, xmm2
	cvtdq2ps xmm3, xmm3;los paso a flotante

	divps xmm2, xmm6;divido por tres
	divps xmm3, xmm6
	
	cvtps2dq xmm2, xmm2
	cvtps2dq xmm3, xmm3;los paso a enteros

	packusdw xmm2, xmm3; junto los valores en un mismo registro
	pshufd xmm2, xmm2, 01011000b ; los acomodo para que queden juntos
	punpcklwd xmm2, xmm7; unpackeo así tengo los bv en dwords en un mismo registro
	
	pcmpeqd xmm7, xmm2; me fijo si hay algun bv igual a cero
	movdqu mascara, xmm7; me guardo la mascara
	mov eax, 0xFFFFFFFF
	pinsrd xmm3, eax, 0
	pshufd xmm3, xmm3, 00000000b ; armo una mascara con todos los bits en 1
	pxor xmm7, xmm3; invierto los bits de xmm7
	ptest xmm7, xmm3; con esto chequeo si son todos cero los bv
	jz .todosCero; si es asi, no necesito hacer ninguna cuenta
	pand xmm2, xmm7; los bv distintos de cero se mantienen, los restantes toman valor cero
	pxor xmm7, xmm3; reestablezco la máscara
	movdqu xmm3, xmm2; copio el bv con ceros
	por xmm2, xmm7; ahora le pongo basura a los que eran ceros, ya que luego voy a dividir y no me conviene que queden ceros si hay algun pixel cuyo bv es cero
	cvtdq2ps xmm2, xmm2; paso bv a flotante
	
	movdqu xmm1, lineade4
	pmulld xmm3, xmm1
	movdqu xmm1, HistoXmm
	paddd xmm3, xmm1; tengo los cuatro punteros a los indices
	
;ahora traigo para cada indice su valor correspondiente
	pextrd eax, xmm3, 0
	mov eax, [eax]
	pinsrd xmm3, eax, 0

	pextrd eax, xmm3, 1
	mov eax, [eax]
	pinsrd xmm3, eax, 1
	
	pextrd eax, xmm3, 2
	mov eax, [eax]
	pinsrd xmm3, eax, 2
	
	pextrd eax, xmm3, 3
	mov eax, [eax]
	pinsrd xmm3, eax, 3
	
	cvtdq2ps xmm3, xmm3; tengo los bn, los paso a flotante

	movdqu xmm7, xmm4
	pxor xmm1, xmm1
	
	punpcklbw xmm4, xmm1; agarro los 2 primeros pixeles
	movdqu xmm5, xmm4
	punpcklwd xmm4, xmm1; tengo el primer pixel
	punpckhwd xmm5, xmm1; tengo el segundo pixel

	punpckhbw xmm7, xmm1; agarro los otros dos pixeles
	movdqu xmm0, xmm7
	punpcklwd xmm7, xmm1; tengo el tercer pixel
	punpckhwd xmm0, xmm1; tengo el cuarto pixel
	
	cvtdq2ps xmm4, xmm4
	cvtdq2ps xmm5, xmm5;paso los pixeles a flotante
	cvtdq2ps xmm7, xmm7
	cvtdq2ps xmm0, xmm0;paso los pixeles a flotante

	pshufd xmm1, xmm3, 00000000b ;bn del primer pixel en xmm1
	mulps xmm4, xmm1
	pshufd xmm1, xmm2, 00000000b ;bv del primer pixel en xmm0
	divps xmm4, xmm1;tengo cr, cg y cb del primer pixel

	pshufd xmm1, xmm3, 01010101b ;bn del segundo pixel en xmm1
	mulps xmm5, xmm1
	pshufd xmm1, xmm2, 01010101b ;bv del segundo pixel en xmm0
	divps xmm5, xmm1;tengo cr, cg y cb del segundo pixel

	pshufd xmm1, xmm3, 10101010b ;bn del tercer pixel en xmm1
	mulps xmm7, xmm1
	pshufd xmm1, xmm2, 10101010b ;bv del tercer pixel en xmm0
	divps xmm7, xmm1;tengo cr, cg y cb del tercer pixel

	pshufd xmm1, xmm3, 11111111b ;bn del cuarto pixel en xmm1
	mulps xmm0, xmm1
	pshufd xmm1, xmm2, 11111111b ;bv del cuarto pixel en xmm0
	divps xmm0, xmm1;tengo cr, cg y cb del cuarto pixel

	cvtps2dq xmm4, xmm4
	cvtps2dq xmm5, xmm5;paso los valores a enteros
	cvtps2dq xmm7, xmm7
	cvtps2dq xmm0, xmm0;paso los valores a enteros

	packusdw xmm4, xmm5; vuelvo a juntar los pixeles
	packusdw xmm7, xmm0; idem
	packuswb xmm4, xmm7; vuelvo a juntar todo
.todosCero:
	movdqu xmm0, mascara; cargo la mascara para saber que bv eran iguales a cero
	pxor xmm7, xmm7
	pblendvb xmm4, xmm7, xmm0; cargo ceros en los pixeles con bv=0

	movdqu [edi], xmm4; los cargo en la salida
	
	add esi, 16
	add edi, 16
	add ecx, 4
	mov ebx, cols
	sub ebx, ecx
	cmp ebx, 0
	jg .colsCalcular
	
	pop eax
	inc eax
	cmp eax, filas
	jl .filasCalcular	
	
.fin:
	mov eax, outt
	finConvencionC 76
	ret
