section .text

%include "macros.mac"

%define inn [ebp+8]
%define outt [ebp+12]
%define color [ebp+16]
%define dataOut [ebp-4]
%define dataIn [ebp-8]
%define widthstep [ebp-12]
%define filas [ebp-16]
%define cols [ebp-20]

global intercambiarAsm

intercambiarAsm:
	convencionC 20

	mov esi, inn
	mov eax, [esi + 8]
	mov eax, [esi + 68]
	mov dataIn, eax
	mov eax, [esi + 72]
	mov widthstep, eax
	mov eax, [esi +  44]
	mov filas, eax
	mov eax, [esi + 40]
	mov cols, eax
	mov edi, outt
	mov eax, [edi + 68]
	mov dataOut, eax
	mov eax, color

;La clave en este código está en la máscara: la instrucción PSHUFB utiliza un registro xmm como máscara, en la cual se coloca un índice
;entre 0 y 15 para cada Byte, correspondiente al número de byte que se desea poner en esa posición. Si el bit mas significativo del byte se pone
;en cero, en ese byte se coloca un cero. Entonces, esto es como cargar los numeros del arreglo "colores" para cada pixel,
;acomodando cada numero segun la DWORD en la que se encuentra cada pixel.
;Ejemplo -> Pixel 2: Byte 4= Rojo, Byte 5= Verde, Byte 6= Azul, Byte 7= Alpha
;	 -> Codigo de colores: rojo = 0 verde = 2 azul = 0
;	 -> Mascara para el pixel 2: Byte 4 = 4, Byte 5= 6, Byte 6= 4, Byte 7= 0x80
;	 -> Resultado: Byte 4= Rojo, Byte 5= Azul, Byte 6= Rojo, Byte 7= 0


	xor ebx, ebx
	mov bl, [eax+2]
	pinsrb xmm7, bl, 0
	add bl, 4
	pinsrb xmm7, bl, 4
	add bl, 4
	pinsrb xmm7, bl, 8
	add bl, 4
	pinsrb xmm7, bl, 12
	mov bl, [eax+1]
	pinsrb xmm7, bl, 1
	add bl, 4
	pinsrb xmm7, bl, 5
	add bl, 4
	pinsrb xmm7, bl, 9
	add bl, 4
	pinsrb xmm7, bl, 13
	mov bl, [eax]
	pinsrb xmm7, bl, 2
	add bl, 4
	pinsrb xmm7, bl, 6
	add bl, 4
	pinsrb xmm7, bl, 10
	add bl, 4
	pinsrb xmm7, bl, 14
	mov bl, 10000000b
	pinsrb xmm7, bl, 3
	pinsrb xmm7, bl, 7
	pinsrb xmm7, bl, 11
	pinsrb xmm7, bl, 15

	xor eax, eax

.filas:
	push eax
	mul DWORD widthstep
	add eax, dataIn
	mov esi, eax; p_inrow
	mov eax, [esp]
	mul DWORD widthstep
	add eax, dataOut
	mov edi, eax; p_outrow
	xor ecx, ecx	
.cols:
	movdqu xmm0, [esi]
	pshufb xmm0, xmm7
	movdqu [edi], xmm0
	
	add esi, 16
	add edi, 16
	add ecx, 4
	mov ebx, cols
	sub ebx, ecx
	cmp ebx, 0
	jg .cols
	
	pop eax
	inc eax
	cmp eax, filas
	jl .filas

	mov eax, outt
	finConvencionC 20
	ret