#define pixel_size 3

__global__ void cu_intercambiarCanales(unsigned char* cu_in,unsigned char* cu_out,
														  unsigned int step,unsigned int height,unsigned int width,
														  unsigned char flags_0,unsigned char flags_1, unsigned char flags_2) {
	unsigned int n_pixel = blockIdx.x * blockDim.x + threadIdx.x; //me da en que numero de pixel estoy!
	if(n_pixel < height * width) {
		unsigned int n_row,n_col;
		unsigned char* pix_in,*pix_out;

		n_row = n_pixel / width;
		n_col = n_pixel % width;

		pix_in = cu_in + n_row * step + pixel_size * sizeof(unsigned char) * n_col;
		pix_out = cu_out + n_row * step + pixel_size * sizeof(unsigned char) * n_col;

		pix_out[0] = pix_in[flags_2];
		pix_out[1] = pix_in[flags_1]; 
		pix_out[2] = pix_in[flags_0];
	}
}

unsigned char *cu_mem_in = 0, *cu_mem_out = 0;
bool cu_mem_init = false;

extern "C" void intercambiarCanales(unsigned char* in_data,unsigned char* out_data,unsigned int width,unsigned int height,unsigned int step,unsigned char flags []) {
	if(!cu_mem_init){
		cudaMalloc((void**)&cu_mem_in,sizeof(unsigned char) * step * height);
		cudaMalloc((void**)&cu_mem_out,sizeof(unsigned char) * step * height);
		cu_mem_init = true;
	}

	cudaMemcpy(cu_mem_in,in_data,sizeof(unsigned char) * step * height,cudaMemcpyHostToDevice);
	dim3 dimBlock(16*16,1);
	dim3 dimGrid((width * height)/dimBlock.x + 1,1); //proceso de a tiras.

	cu_intercambiarCanales<<<dimGrid , dimBlock>>>(cu_mem_in,cu_mem_out,step,height,width,flags[0],flags[1],flags[2]);

	cudaMemcpy(out_data,cu_mem_out,sizeof(unsigned char) * step * height,cudaMemcpyDeviceToHost);
}

extern "C" void cuda_clean() {
	if(cu_mem_init) {
		cudaFree(cu_mem_in);
		cudaFree(cu_mem_out);
	}
}
